dnl **********************************************************************
dnl
dnl Copyright (c) 2008
dnl UChicago, LLC, operator of Argonne National Laboratory
dnl
dnl All Rights Reserved
dnl
dnl Author: Boyana Norris  norris@mcs.anl.gov
dnl **********************************************************************

dnl Common variables used in other m4 macros in this project
AC_DEFUN([COMMON_VARS], [

AC_SUBST(SHLIB_EXT)
AC_SUBST(SHLIB_EXT_LIST)

AC_REQUIRE([AC_LTDL_SHLIBEXT])
if test -n "$SHLIB_EXT" ; then
   SHLIB_EXT=so
   SHLIB_EXT_LIST=so
else
   SHLIB_EXT_LIST="$SHLIB_EXT"
fi
case $host in
 *-*-darwin* )
	SHLIB_EXT_LIST="$SHLIB_EXT dylib"
	;;
 *)
	;;
esac

	soft_dirs="
		$prefix
		/usr
		/usr/local
		/usr/local/packages
		/opt
		/opt/local
		/sw
		/software
		/soft/apps
		/home/software
		$HOME/software
		$HOME/soft
	"
	soft_path=
	for p in $softdirs ; do 
		soft_path="$soft_path:$p"
	done
        soft_path=${soft_path/:/}
	include_dirs=""
	include_path=""
	for p in $soft_dirs ; do
		include_dirs="$include_dirs $p/include"
		include_path="$include_path:$p/include"
	done
        include_path=${include_path/:/}
	lib_dirs=""
	lib_path=""
	libsubdirs="lib"
	case $host_cpu in
	   *64)
		libsubdirs="lib64 $libsubdirs"
		;;
	   *)
		;;
	esac

	for p in $soft_dirs ; do
		for l in $libsubdirs ; do
			lib_dirs="$lib_dirs $p/$l"
			lib_path="$lib_path:$p/$l"
		done
	done
        lib_path=${lib_path/:/}
])
