#include "cqosdb.hxx"
#include "libpq-fe.h"

#include "stdio.h"
using namespace cqosdb;

void Connect()
{
//Following two lines get connection information from the user
//const char* conninfo="dbname = perfdb";
//database.setConnectionInfo(conninfo);
MetaDB database;

//Next line grabs connection info from PerfDMF configuration file.
const char* conninfo = database.getConnectionInfoFromDefaultPerfDMFConfig().c_str();

bool bval = database.connect();
if(bval)
	fprintf(stderr,"Connection is successful\n");
else
	fprintf(stderr,"Connection is unsuccessful\n");

database.resetQuery();



/*** test executeQuery ***/
/*string exestring("insert into metadata_parameters values (0,0, $1, $2, $3, $4)");

database.bindParameters(1, "cat1");
database.bindParameters(2, "nsplits");
database.bindParameters(3, "string");
database.bindParameters(4, "376.000");

ResultSet Res;
database.executeQuery_bindParam(exestring, &Res);*/

/*ResultSet Res;
string exestring("select * from metadata_parameters");
database.executeQuery(exestring, &Res);

int len = Res.getNumberOfRows();
fprintf(stderr,"result size %d\n",len);fflush(stderr);

string result;
for(int i=0;i<len;++i)
{
        Res.getElement(i,5,&result);
        fprintf(stderr,"row %d id %s\n",i,result.c_str());
}*/

string p1Name("nsplits"), p2Name("splits");
DefaultProperty p1(p1Name, "double", 345.00), p2(p2Name, "double", 97.00);
DefaultProperty q1(p1Name, "double", 45553434.00), q2(p2Name, "double", 453287.00);

p1.setTrialID(0);
p1.setInterEvt("phase1");
/*printf(p1.getDBConditions().c_str());
printf("\n");
printf(p1.getDBConditions(1, 3.5, LT).c_str());*/

PropertySet pc1, pc2;
pc1.addAParameter(p1);
pc1.addAParameter(p2);

pc2.addAParameter(q1);
pc2.addAParameter(q2);

double value;
pc1.getParameterAt(0)->getValue(&value);
printf("size= %d, element1=%e\n", pc1.getNumOfParameters(), value);
printf("table name =%s\n", pc1.getTBName().c_str());

map<string, double> tMap;
map<string, int> rMap;

tMap[p1Name]=21.00;
tMap[p2Name]=9.00;
rMap[p1Name]=LT;
rMap[p2Name]=LT;

if (pc1.compareWith(pc2, tMap, rMap))
	printf("true\n");
else
	printf("false\n");
	
int tbIndex[2];
tbIndex[0] = 1;
tbIndex[1]=2;

printf(pc1.getDBConditions(tbIndex,tMap, rMap).c_str());

PropertySetComparator psc(pc1, pc2);
psc.setToleranceAt(p1Name, 21);
psc.setToleranceAt(p2Name, 9);
psc.setRelationAt(p1Name, BT);
psc.setRelationAt(p2Name, BT);

if (psc.doCompare())
	printf("true\n");
else
	printf("false\n");

database.storeParameterSet(0, "phase1", pc1);
database.storeParameterSet(0, "phase1", pc2);

DefaultProperty newP1(p1Name, "double"), newP2(p2Name, "double");
PropertySet newPS;

newPS.addAParameter(newP1);
newPS.addAParameter(newP2);
double newV1, newV2;

database.getParameterSet(0,"phase1",&newPS);
newPS.getParameterAt(0)->getValue(&newV1);
newPS.getParameterAt(1)->getValue(&newV2);
printf("get value %e %e from DB\n", newV1, newV2);

database.getParameter(0,"phase1",&newP1);
newP1.getValue(&newV1);
printf("get parameter value %e from DB\n", newV1);

database.resetQuery();
ResultSet Res;

database.getMatchingTrialsBetween(pc1, pc2, &Res);

int len = Res.getNumberOfRows();
fprintf(stderr,"result size %d\n",len);fflush(stderr);

int result;
for(int i=0;i<len;++i)
{
        Res.getElement(i,"trial",&result);
        fprintf(stderr,"row %d id %d\n",i,result);
}

vector<double> epsilon;
epsilon.push_back(100.0);
epsilon.push_back(20.0);

Res.clear();

database.getMatchingTrials(pc1, epsilon, &Res);
len = Res.getNumberOfRows();
fprintf(stderr,"result size %d\n",len);fflush(stderr);

for(int i=0;i<len;++i)
{
        Res.getElement(i,"trial",&result);
        fprintf(stderr,"row %d id %d\n",i,result);
}

database.disconnect();
}

int main()
{

Connect();

return 0;
}
